image: docker:latest
services:
  - docker:dind
  
variables:
  BACKEND_TEST_IMAGE: ${CI_REGISTRY_IMAGE}/backend:${CI_BUILD_REF_NAME}_test
  BACKEND_RELEASE_IMAGE: ${CI_REGISTRY_IMAGE}/release:${CI_BUILD_REF_NAME}_test
  DOCKER_DRIVER: overlay
  
stages:
  - prepare
  - build
  - test
  - release
  - deploy
  
cache:
  paths:
    - target/


maven-build:
  image: maven:latest
  stage: prepare
  script:
    - mvn package
    - ls -alh
    - ls -l target/
  artifacts:
    paths:
      - target/*.jar
      
      
docker-build:
  stage: build
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker build --pull -t $BACKEND_TEST_IMAGE .
    - docker push $BACKEND_TEST_IMAGE
  only:
  - master

docker-test:
  stage: test
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker run --name springpetclinic -d $BACKEND_TEST_IMAGE
    - docker ps -a | grep springpetclinic
   # - docker pull curlimages/curl:7.68.0
    - sleep 30
    - docker run --rm --link springpetclinic:springpetclinic curlimages/curl:7.68.0 curl springpetclinic:8080

docker-release:
  stage: release
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker pull $BACKEND_TEST_IMAGE
    - docker tag $BACKEND_TEST_IMAGE $BACKEND_RELEASE_IMAGE
    - docker push $BACKEND_RELEASE_IMAGE
    - docker rmi -f $BACKEND_TEST_IMAGE

staging:
    stage: deploy
    image: ruby:latest
    before_script:
        - apt-get update -qy
        - apt-get install -y ruby-dev
        - gem install dpl

    script:
        - dpl --provider=heroku --app=$HEROKU_APP_STAGING --api-key=$HEROKU_API_KEY
    only:
        - master

      
